// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk f_rotate2d_00.pov +W1200 +h900  (quick and ugly)
//     yuqk f_rotate2d_00.pov +W1200 +h900 +a0.05 +am2 +r3 +j3.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare Camera01y = camera {
    orthographic
    location <0,2,0>
    direction -y
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*z*max(1,image_height/image_width)
}
#declare Camera01x = camera {
    orthographic
    location <2,0,0>
    direction -x
    right VarOrthoMult*z*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#include "functions.inc"
// Function f_ellipsoid defined in functions.inc
// Function f_rotate2d defined in functions.inc
#declare Fn00 = function (x,y,z,_exp) {
    f_ellipsoid(x,y-0.7,z,1,0.2,0.2,0.2,_exp,0)
}
#declare Fn01 = function (x,y,z,_v,_exp) {
    Fn00(x,f_dec2x_f32(_v,0),f_dec2x_f32(_v,1),_exp)
}
// Sphere
#declare FnRotX_zero = function (x,y,z) {
    Fn01(x,y,z,f_rotate2d(x,y,z,0,  0),2.0)
}
// Rounded box
#declare FnRotX_pos65 = function (x,y,z) {
    Fn01(x,y,z,f_rotate2d(x,y,z,0,+65),3.0)
}
// Octahedron
#declare FnRotX_neg65 = function (x,y,z) {
    Fn01(x,y,z,f_rotate2d(x,y,z,0,-65),1.0)
}
#declare IsoZero = isosurface {
    function { FnRotX_zero(x,y,z) }
    contained_by { box { <-1.1,-1.1,-1.1>,<1.1,1.1,1.1> } }
    threshold 0
    accuracy 0.0005
    max_gradient 5.3
    jitter on
    pigment { Red }
}
#declare IsoPos45 = isosurface {
    function { FnRotX_pos65(x,y,z) }
    contained_by { box { <-1.1,-1.1,-1.1>,<1.1,1.1,1.1> } }
    threshold 0
    accuracy 0.0005
    max_gradient 17.3
    jitter on
    pigment { Red }
}
#declare IsoNeg45 = isosurface {
    function { FnRotX_neg65(x,y,z) }
    contained_by { box { <-1.1,-1.1,-1.1>,<1.1,1.1,1.1> } }
    threshold 0
    accuracy 0.0005
    max_gradient 5.3
    jitter on
    pigment { Red }
}

//--- scene ---
    camera { Camera00 }
    light_source { Light00 }
//  camera { Camera01x }
//  camera { Camera01y }
//  camera { Camera01z }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { IsoZero }
    object { IsoPos45 }
    object { IsoNeg45 }
