// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk f_toupie_02.pov +W1200 +h900  (quick and ugly)
//     yuqk f_toupie_02.pov +W1200 +h900 +a0.05 +am2 +r3 +j3.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare Camera01y = camera {
    orthographic
    location <0,2,0>
    direction -y
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*z*max(1,image_height/image_width)
}
#declare Camera01x = camera {
    orthographic
    location <2,0,0>
    direction -x
    right VarOrthoMult*z*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#include "functions.inc"
// Function f_toupie defined in functions.inc
#declare AlizarinCrimson = srgb <0.8902,0.14902,0.21176>;
#declare Iso02 = isosurface {
    function { f_toupie(x,y,z,1,0.5,0.005,3) }
    contained_by { box { -2.0,2.0 } }
    threshold 0
    accuracy 0.0005
    max_gradient 0.8
    pigment { AlizarinCrimson }
}

//--- scene ---
    camera { Camera00 }
    light_source { Light00 }
//  camera { Camera01x }
//  camera { Camera01y }
//  camera { Camera01z }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { Iso02 }
