// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk cubic_00.pov +W1200 +h900  (quick and ugly)
//     yuqk cubic_00.pov +W1200 +h900 +a0.05 +am2 +r3 +j5.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Red = srgb <1,0,0>;
#declare Green = srgb <0,1,0>;
#declare Blue = srgb <0,0,1>;
#declare Pred = pigment { Red }
#declare Pgreen = pigment { Green }
#declare Pblue = pigment { Blue }
#declare Yellow = srgb <1,1,0>;
#declare Pyellow = pigment { Yellow }
#declare Cyan = srgb <0,1,1>;
#declare Pcyan = pigment { Cyan }
#declare Magenta = srgb <1,0,1>;
#declare Pmagenta = pigment { Magenta }
#declare PigmentCubic = pigment {
    cubic
    pigment { Pred }
    pigment { Pgreen }
    pigment { Pblue }
    pigment { Pyellow }
    pigment { Pcyan }
    pigment { Pmagenta }
}
#declare TextureCubic = texture { pigment { PigmentCubic } }
#declare CylXn = cylinder { -2*x, -0.2*x, 0.02 }
#declare CylYn = cylinder { -2*y, -0.2*y, 0.02 }
#declare CylZn = cylinder { -2*z, -0.2*z, 0.02 }
#declare CylXp = cylinder { +0.2*x, +2*x, 0.02 }
#declare CylYp = cylinder { +0.2*y, +2*y, 0.02 }
#declare CylZp = cylinder { +0.2*z, +2*z, 0.02 }
#declare Sph00 = sphere { 0, 0.15 }
#declare UnionOfCylsForCubic = union {
    object { CylXn }
    object { CylYn }
    object { CylZn }
    object { CylXp }
    object { CylYp }
    object { CylZp }
    object { Sph00 }
}
#declare ObjectCubic = object {
    UnionOfCylsForCubic
    texture { TextureCubic }
}

//--- scene ---
    camera { Camera00 }
    light_source { Light00 }
    object { ObjectCubic }
