// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk dens_object_00.pov +W900 +h900  (quick and ugly)
//     yuqk dens_object_00.pov +W900 +h900 +a0.05 +am2 +r3 +j5.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare VarOrthoMult =
    2.2/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Plane00 = plane { -z, 0 }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#declare Black = srgb <0,0,0>;
#declare ColorMap = color_map {
    [ -1 Red ]
    [  0 Black ]
    [  1 Green ]
}
#declare Sphere00 = sphere { 0, 0.5 }
#declare PigListObj = pigment {
    dens_object {
        Sphere00
        sphere { 0, 0.40 scale <1,1,0.07> translate <+0.60,+0.60,0> }
        sphere { 0, 0.40 scale <1,1,0.07> translate <-0.60,-0.60,0> }
        box { <-1,-.2,0>, <1,0.2,1> rotate -45*z }
        exponent 1.2
        radius 0.067
        recursion_limit 7
        samples 44
    }
    function_interval
    color_map { ColorMap }
    //scale 7
    //warp { turbulence 0.07 octaves 5 omega 0.67 lambda 3.123 }
    //scale 1/7
}
#declare TxtrListObj = texture { pigment { PigListObj } }
#declare ObjListObj = object { Plane00 texture { TxtrListObj } }

//--- scene ---
//  camera { Camera00 }
    light_source { Light00 }
    camera { Camera01z }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { ObjListObj }
