// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk hard_object_01.pov +W1200 +h900  (quick and ugly)
//     yuqk hard_object_01.pov +W1200 +h900 +a0.05 +am2 +r3 +j3.33 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings { assumed_gamma 1 shadow_tolerance 1e-05 }
#declare Grey50 = srgb <0.5,0.5,0.5>;
background { Grey50 }
#declare Camera00 = camera {
    perspective
    location <3,3,-3.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare VarOrthoMult =
    2.0/max(image_width/image_height,image_height/image_width);
#declare Camera01z = camera {
    orthographic
    location <0,0,-2>
    direction z
    right VarOrthoMult*x*max(1,image_width/image_height)
    up VarOrthoMult*y*max(1,image_height/image_width)
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,150,-250>, White }
#declare Plane00 = plane { -z, 0 }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#declare TextR = text {
    ttf "timrom.ttf" "R"
    0.1, 0
    translate <-0.0,-0.0,-0.05>
    scale <1.2,1.2,1>
}
#declare FnHard01 = function {
    pattern {
        hard_object {
            TextR
            radius 0.012
            recursion_limit 12
            samples 44
        }
        function_interval // phase -0.15
        warp { black_hole <1,0.5,0> 1.1 type 1 strength 0.4 falloff 2.7 }
    }
}
#declare Black = srgb <0,0,0>;
#declare ColorMap = color_map {
    [ -1 Red ]
    [  0 Black ]
    [  1 Green ]
}
#declare PigHard = pigment {
    function { FnHard01(x,y,z) }
    function_interval
    color_map { ColorMap }
}
#declare FinHard = finish { emission rgb <1,1,1> }
#declare TxtrHard = texture {
    pigment { PigHard }
    finish { FinHard }
}
#declare ObjectHard = object { Plane00 texture { TxtrHard } }
#declare IsoHardObj = isosurface {
    function { FnHard01(x,y,z) }
    contained_by { box { <-1,-1,-0.1>,<1.2,1.2,0.1> } }
    threshold 0
    accuracy 0.001
    max_gradient 367.333
    jitter on
    max_trace 1
    pigment { Green }
}

//--- scene ---
    light_source { Light00 }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    camera { Camera00 }
    object { IsoHardObj }
//  camera { Camera01z }
//  object { ObjectHard }
