// This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
// International Public License.
// Visit https://creativecommons.org/licenses/by-sa/4.0/.
// SPDX-License-Identifier: CC-BY-SA-4.0
//     yuqk irid_00.pov +W1200 +h900  (quick and ugly)
//     yuqk irid_00.pov +W1200 +h900 +a0.05 +am2 +r3 +j4.53 +d +p
#version unofficial 3.8; // yuqk
#if (file_exists("version.inc"))
    #include "version.inc"
#end
#if (!defined(Fork_yuqk))
    #error "This POV-Ray SDL code requires the yuqk fork."
#end
global_settings {
    assumed_gamma 1
    irid_wavelength rgb <0.7,0.52,0.48>
}
#declare Grey05 = srgb <0.05,0.05,0.05>;
background { Grey05 }
#declare Camera00 = camera {
    perspective
    location <1,1,-7.001>
    sky y
    angle 35
    right x*(image_width/image_height)
    look_at <0,0,0>
}
#declare White = srgb <1,1,1>;
#declare Light00 = light_source { <50,50,-2500>, White }
#declare Red = srgb <1,0,0>;
#declare CylinderX = cylinder { -1*x, 1*x, 0.01 pigment { Red } }
#declare Green = srgb <0,1,0>;
#declare CylinderY = cylinder { -1*y, 1*y, 0.01 pigment { Green } }
#declare Blue = srgb <0,0,1>;
#declare CylinderZ = cylinder { -1*z, 1*z, 0.01 pigment { Blue } }
#declare Fin00 = finish { diffuse 0.2 specular 1 roughness 0.001 }
#declare Pig00 = pigment { White }
#declare Txtr00 = texture { pigment { Pig00 } finish { Fin00 } }
#declare Sphere00 = sphere { 0, 0.45 }
#declare Obj00 = object { Sphere00 texture { Txtr00 } }
#declare Obj00t0 = object {
    Obj00
    finish { irid {0.25 thickness 0.5 it_amount 0.75 } }
    translate -x
}
#declare Obj00t1 = object {
    Obj00
    finish { irid {0.50 thickness 0.5 it_amount 0.75 } }
}
#declare Obj00t2 = object {
    Obj00
    finish { irid {0.75 thickness 0.5 it_amount 0.75 } }
    translate +x
}
#declare Obj00m0 = object {
    Obj00
    finish { irid {0.50 thickness 0.5 it_amount 0.75 } }
    translate -x
}
#declare Obj00m1 = object {
    Obj00
    finish { irid {0.50 thickness 2.0 it_amount 0.75 } }
}
#declare Obj00m2 = object {
    Obj00
    finish { irid {0.50 thickness 8.0 it_amount 0.75 } }
    translate +x
}
#declare Obj00b0 = object {
    Obj00
    finish { irid {0.50 thickness 2.0 it_amount 0.10 } }
    translate -x
}
#declare Obj00b1 = object {
    Obj00
    finish { irid {0.50 thickness 2.0 it_amount 1.00 } }
}
#declare Obj00b2 = object {
    Obj00
    finish { irid {0.50 thickness 2.0 it_amount 2.00 } }
    translate +x
}
#declare UnionTopRow = union {
    object { Obj00t0 }
    object { Obj00t1 }
    object { Obj00t2 }
    translate +y
}
#declare UnionMidRow = union {
    object { Obj00m0 }
    object { Obj00m1 }
    object { Obj00m2 }
}
#declare UnionBotRow = union {
    object { Obj00b0 }
    object { Obj00b1 }
    object { Obj00b2 }
    translate -y
}

//--- scene ---
    light_source { Light00 }
    camera { Camera00 }
    object { CylinderX }
    object { CylinderY }
    object { CylinderZ }
    object { UnionTopRow }
    object { UnionMidRow }
    object { UnionBotRow }
